/**
 * metadata/AdhocQueryMetadata.java
 *
 * File generated from the AdhocQueryMetadata uml Class
 * Generated by the Acceleo UML 2.1 to Java generator module (Obeo)
 */
package net.ihe.gazelle.metadata.model;

// End of user code
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.DiscriminatorValue;
import javax.persistence.ElementCollection;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.OneToMany;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

import net.ihe.gazelle.hql.HQLQueryBuilder;
import net.ihe.gazelle.query.ReturnTypeType;

import org.jboss.seam.annotations.Name;


/**
 * Description of the class AdhocQueryMetadata.
 *
 */
@Entity
@Name("adhocQueryMetadata")
@DiscriminatorValue("AdhocQuery")

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "AdhocQueryMetadata")
@XmlRootElement(name = "AdhocQueryMetadata")
public class AdhocQueryMetadata extends net.ihe.gazelle.metadata.model.RegistryObjectMetadata {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	@ElementCollection(targetClass=ReturnTypeType.class)
	@JoinTable(
            name="adhoc_return_types", 
            joinColumns = {
            		@JoinColumn(name="id")
            }
    )
    @Enumerated(EnumType.STRING)
	@Column(name="return_type_val")
	private List<ReturnTypeType> returnTypes;
	
	@OneToMany(cascade = { CascadeType.ALL })
	@JoinTable(name = "adhoc_query_extra_constraints")
	protected List<ConstraintSpecification> extraConstraintSpecifications;

	public List<ConstraintSpecification> getExtraConstraintSpecifications() {
		return extraConstraintSpecifications;
	}

	public void setExtraConstraintSpecifications(List<ConstraintSpecification> extraConstraintSpecifications) {
		this.extraConstraintSpecifications = extraConstraintSpecifications;
	}

	public List<ReturnTypeType> getReturnTypes() {
		return returnTypes;
	}

	public void setReturnTypes(List<ReturnTypeType> returnTypes) {
		this.returnTypes = returnTypes;
	}
	
	
	public static boolean listHasValidUuid(List<AdhocQueryMetadata> ladqm, String uuid){
		
		for (AdhocQueryMetadata adhocQueryMetadata : ladqm) {
			if(adhocQueryMetadata.getUuid().equals(uuid)){
				return true;
			}
		}
		return false;
	}
	
	public static AdhocQueryMetadata searchAdhocQueryMetadataByUuid(List<AdhocQueryMetadata> ladqm, String uuid){
		
		for (AdhocQueryMetadata adhocQueryMetadata : ladqm) {
			if(adhocQueryMetadata.getUuid().equals(uuid)){
				return adhocQueryMetadata;
			}
		}
		return null;
	}
	
	public static List<AdhocQueryMetadata> getListAdhocQueryMetadatas(){
		HQLQueryBuilder<AdhocQueryMetadata> hql = new HQLQueryBuilder<AdhocQueryMetadata>(AdhocQueryMetadata.class);
		return hql.getList();
	}
	
}